isc-dhcp: update to 4.3.3. Migrate from oldplackages

Signed-off-by: Antony Antony <antony@phenome.org>
This commit is contained in:
Antony Antony
2016-03-25 13:17:46 +01:00
parent 4457604f3b
commit 7f594309bf
15 changed files with 964 additions and 0 deletions
+281
View File
@@ -0,0 +1,281 @@
#!/bin/sh
make_resolv_conf() {
if [ x"$new_domain_name_servers" != x ]; then
cat /dev/null > /etc/resolv.conf.dhclient
chmod 644 /etc/resolv.conf.dhclient
if [ x"$new_domain_search" != x ]; then
echo search $new_domain_search >> /etc/resolv.conf.dhclient
elif [ x"$new_domain_name" != x ]; then
# Note that the DHCP 'Domain Name Option' is really just a domain
# name, and that this practice of using the domain name option as
# a search path is both nonstandard and deprecated.
echo search $new_domain_name >> /etc/resolv.conf.dhclient
fi
for nameserver in $new_domain_name_servers; do
echo nameserver $nameserver >>/etc/resolv.conf.dhclient
done
elif [ "x${new_dhcp6_name_servers}" != x ] ; then
cat /dev/null > /etc/resolv.conf.dhclient6
chmod 644 /etc/resolv.conf.dhclient6
if [ "x${new_dhcp6_domain_search}" != x ] ; then
echo search ${new_dhcp6_domain_search} >> /etc/resolv.conf.dhclient6
fi
for nameserver in ${new_dhcp6_name_servers} ; do
echo nameserver ${nameserver} >> /etc/resolv.conf.dhclient6
done
fi
# if both v4 and v6 clients are running, concatenate results
cat /etc/resolv.conf.* > /etc/resolv.conf
}
# Must be used on exit. Invokes the local dhcp client exit hooks, if any.
exit_with_hooks() {
exit_status=$1
if [ -f /etc/dhclient-exit-hooks ]; then
. /etc/dhclient-exit-hooks
fi
# probably should do something with exit status of the local script
exit $exit_status
}
# Invoke the local dhcp client enter hooks, if they exist.
if [ -f /etc/dhclient-enter-hooks ]; then
exit_status=0
. /etc/dhclient-enter-hooks
# allow the local script to abort processing of this state
# local script must set exit_status variable to nonzero.
if [ $exit_status -ne 0 ]; then
exit $exit_status
fi
fi
###
### DHCPv4 Handlers
###
if [ x$new_broadcast_address != x ]; then
new_broadcast_arg="broadcast $new_broadcast_address"
fi
if [ x$new_subnet_mask != x ]; then
new_subnet_arg="netmask $new_subnet_mask"
fi
if [ x$alias_subnet_mask != x ]; then
alias_subnet_arg="netmask $alias_subnet_mask"
fi
if [ x$reason = xMEDIUM ]; then
# Linux doesn't do mediums (ok, ok, media).
exit_with_hooks 0
fi
if [ x$reason = xPREINIT ]; then
if [ x$alias_ip_address != x ]; then
# Bring down alias interface. Its routes will disappear too.
ifconfig $interface:0- 0.0.0.0
fi
ifconfig $interface 0.0.0.0 up
# We need to give the kernel some time to get the interface up.
sleep 1
exit_with_hooks 0
fi
if [ x$reason = xARPCHECK ] || [ x$reason = xARPSEND ]; then
exit_with_hooks 0
fi
if [ x$reason = xBOUND ] || [ x$reason = xRENEW ] || \
[ x$reason = xREBIND ] || [ x$reason = xREBOOT ]; then
current_hostname=`hostname`
if [ x$current_hostname = x ] || \
[ x$current_hostname = x$old_host_name ]; then
if [ x$current_hostname = x ] || \
[ x$new_host_name != x$old_host_name ]; then
hostname $new_host_name
fi
fi
if [ x$old_ip_address != x ] && [ x$alias_ip_address != x ] && \
[ x$alias_ip_address != x$old_ip_address ]; then
# Possible new alias. Remove old alias.
ifconfig $interface:0- 0.0.0.0
fi
if [ x$old_ip_address != x ] && [ x$old_ip_address != x$new_ip_address ]; then
# IP address changed. Bringing down the interface will delete all routes,
# and clear the ARP cache.
ifconfig $interface 0.0.0.0 down
fi
if [ x$old_ip_address = x ] || [ x$old_ip_address != x$new_ip_address ] || \
[ x$reason = xBOUND ] || [ x$reason = xREBOOT ]; then
ifconfig $interface $new_ip_address $new_subnet_arg \
$new_broadcast_arg
for router in $new_routers; do
if [ "x$new_subnet_mask" = "x255.255.255.255" ] ; then
route add -host $router dev $interface
fi
route add default gw $router
done
fi
if [ x$new_ip_address != x$alias_ip_address ] && [ x$alias_ip_address != x ];
then
ifconfig $interface:0- 0.0.0.0
ifconfig $interface:0 $alias_ip_address $alias_subnet_arg
route add -host $alias_ip_address $interface:0
fi
make_resolv_conf
exit_with_hooks 0
fi
if [ x$reason = xEXPIRE ] || [ x$reason = xFAIL ] || [ x$reason = xRELEASE ] \
|| [ x$reason = xSTOP ]; then
if [ x$alias_ip_address != x ]; then
# Turn off alias interface.
ifconfig $interface:0- 0.0.0.0
fi
if [ x$old_ip_address != x ]; then
# Shut down interface, which will delete routes and clear arp cache.
ifconfig $interface 0.0.0.0 down
fi
if [ x$alias_ip_address != x ]; then
ifconfig $interface:0 $alias_ip_address $alias_subnet_arg
route add -host $alias_ip_address $interface:0
fi
# remove v4 dns configuration for this interface
rm /etc/resolv.conf.dhclient
cat /etc/resolv.conf.* > /etc/resolv.conf
exit_with_hooks 0
fi
if [ x$reason = xTIMEOUT ]; then
if [ x$alias_ip_address != x ]; then
ifconfig $interface:0- 0.0.0.0
fi
ifconfig $interface $new_ip_address $new_subnet_arg \
$new_broadcast_arg
set $new_routers
if ping -q -c 1 $1; then
if [ x$new_ip_address != x$alias_ip_address ] && \
[ x$alias_ip_address != x ]; then
ifconfig $interface:0 $alias_ip_address $alias_subnet_arg
route add -host $alias_ip_address dev $interface:0
fi
for router in $new_routers; do
if [ "x$new_subnet_mask" = "x255.255.255.255" ] ; then
route add -host $router dev $interface
fi
route add default gw $router
done
make_resolv_conf
exit_with_hooks 0
fi
ifconfig $interface 0.0.0.0 down
exit_with_hooks 1
fi
###
### DHCPv6 Handlers
###
if [ x$reason = xPREINIT6 ]; then
# Ensure interface is up.
ifconfig ${interface} up
# Remove any stale addresses from aborted clients.
ip -f inet6 addr flush dev ${interface} scope global
exit_with_hooks 0
fi
if [ x${old_ip6_prefix} != x ] || [ x${new_ip6_prefix} != x ] ; then
echo Prefix ${reason} old=${old_ip6_prefix} new=${new_ip6_prefix}
exit_with_hooks 0
fi
if [ x$reason = xBOUND6 ]; then
if [ x${new_ip6_address} = x ] || [ x${new_ip6_prefixlen} = x ] ; then
exit_with_hooks 2;
fi
ifconfig ${interface} add ${new_ip6_address}/${new_ip6_prefixlen}
# Check for nameserver options.
make_resolv_conf
### <<
# Set up softwire tunnel
if [ x${new_dhcp6_softwire} != x ] ; then
/etc/init.d/dhclient stop
ifconfig ${interface} 0.0.0.0
ip -6 tunnel add tun0 mode ipip6 \
remote ${new_dhcp6_softwire} \
local ${new_ip6_address} \
dev ${interface} encaplimit none
ip link set tun0 up
ip route add default dev tun0
fi
### >>
exit_with_hooks 0
fi
if [ x$reason = xRENEW6 ] || [ x$reason = xREBIND6 ]; then
if [ x${new_ip6_address} = x ] || [ x${new_ip6_prefixlen} = x ] ; then
exit_with_hooks 2;
fi
ifconfig ${interface} add ${new_ip6_address}/${new_ip6_prefixlen}
# Make sure nothing has moved around on us.
# Nameservers/domains/etc.
if [ "x${new_dhcp6_name_servers}" != "x${old_dhcp6_name_servers}" ] ||
[ "x${new_dhcp6_domain_search}" != "x${old_dhcp6_domain_search}" ] ; then
make_resolv_conf
fi
exit_with_hooks 0
fi
if [ x$reason = xDEPREF6 ]; then
if [ x${new_ip6_address} = x ] ; then
exit_with_hooks 2;
fi
# Busybox ifconfig has no way to communicate this to the kernel, so ignore it
exit_with_hooks 0
fi
if [ x$reason = xEXPIRE6 -o x$reason = xRELEASE6 -o x$reason = xSTOP6 ]; then
if [ x${old_ip6_address} = x ] || [ x${old_ip6_prefixlen} = x ] ; then
exit_with_hooks 2;
fi
ifconfig ${interface} del ${old_ip6_address}/${old_ip6_prefixlen}
# remove v6 dns configuration for this interface
rm /etc/resolv.conf.dhclient6
cat /etc/resolv.conf.* > /etc/resolv.conf
### <<
# Tear down softwire tunnel
if [ x${old_dhcp6_softwire} != x ] ; then
ip link set tun0 down
ip tunnel del tun0
fi
### >>
exit_with_hooks 0
fi
exit_with_hooks 0
+30
View File
@@ -0,0 +1,30 @@
#!/bin/sh /etc/rc.common
START=60
lease_file=/var/dhclient.leases
config_file=/etc/dhclient.conf
pid_file=/var/run/dhclient.pid
script_file=/usr/sbin/dhclient-script
start() {
/usr/sbin/dhclient -q -nw -cf $config_file -lf $lease_file -pf $pid_file -sf $script_file `/sbin/uci get network.wan.ifname`
if [ $? -ne 0 ]; then
return 1
fi
}
stop() {
if [ ! -e $pid_file ]; then
return 1
fi
kill -9 `cat $pid_file`
if [ $? -ne 0 ]; then
return 1
fi
rm $pid_file
}
+2
View File
@@ -0,0 +1,2 @@
option dhcp6.softwire code 54 = ip6-address;
also request dhcp6.softwire;
+30
View File
@@ -0,0 +1,30 @@
#!/bin/sh /etc/rc.common
START=60
lease_file=/var/dhclient6.leases
config_file=/etc/dhclient6.conf
pid_file=/var/run/dhclient6.pid
script_file=/usr/sbin/dhclient-script
start() {
/usr/sbin/dhclient -q -nw -6 -cf $config_file -lf $lease_file -pf $pid_file -sf $script_file `/sbin/uci get network.wan.ifname`
if [ $? -ne 0 ]; then
return 1
fi
}
stop() {
if [ ! -e $pid_file ]; then
return 1
fi
kill -9 `cat $pid_file`
if [ $? -ne 0 ]; then
return 1
fi
rm $pid_file
}
+13
View File
@@ -0,0 +1,13 @@
# dhcpd.conf
authoritative;
default-lease-time 3600;
max-lease-time 86400;
option domain-name-servers 192.168.1.1;
subnet 192.168.1.0 netmask 255.255.255.0 {
range 192.168.1.10 192.168.1.50;
option routers 192.168.1.1;
}
+33
View File
@@ -0,0 +1,33 @@
#!/bin/sh /etc/rc.common
START=65
lease_file=/tmp/dhcpd.leases
config_file=/etc/dhcpd.conf
pid_file=/var/run/dhcpd.pid
start() {
if [ ! -e $lease_file ]; then
touch $lease_file
fi
/usr/sbin/dhcpd -q -cf $config_file -lf $lease_file -pf $pid_file $dhcp_ifs
if [ $? -ne 0 ]; then
return 1
fi
}
stop() {
if [ ! -e $pid_file ]; then
return 1
fi
kill -9 `cat $pid_file`
if [ $? -ne 0 ]; then
return 1
fi
rm $pid_file
}
+30
View File
@@ -0,0 +1,30 @@
# dhcpd6.conf
authoritative;
default-lease-time 3600;
max-lease-time 86400;
# Enable RFC 5007 support
#allow leasequery;
# Global definitions for name server address(es) and domain search list
#option dhcp6.name-servers 3ffe:501:ffff:100:200:ff:fe00:3f3e;
#option dhcp6.domain-search "test.example.com","example.com";
# Set preference to 255 (maximum) in order to avoid waiting for
# additional servers when there is only one
#option dhcp6.preference 255;
# Server side command to enable rapid-commit (2 packet exchange)
#option dhcp6.rapid-commit;
# The delay before information-request refresh
# (minimum is 10 minutes, maximum one day, default is to not refresh)
# (set to 6 hours)
#option dhcp6.info-refresh-time 3600;
subnet6 3ffe:501:ffff:101::/64 {
# Use the whole /64 prefix for clients
range6 3ffe:501:ffff:101:: /64;
}
+33
View File
@@ -0,0 +1,33 @@
#!/bin/sh /etc/rc.common
START=65
lease_file=/var/dhcpd6.leases
config_file=/etc/dhcpd6.conf
pid_file=/var/run/dhcpd6.pid
start() {
if [ ! -e $lease_file ]; then
touch $lease_file
fi
/usr/sbin/dhcpd -q -6 -cf $config_file -lf $lease_file -pf $pid_file $dhcp_ifs
if [ $? -ne 0 ]; then
return 1
fi
}
stop() {
if [ ! -e $pid_file ]; then
return 1
fi
kill -9 `cat $pid_file`
if [ $? -ne 0 ]; then
return 1
fi
rm $pid_file
}
+53
View File
@@ -0,0 +1,53 @@
#!/bin/sh /etc/rc.common
# Copyright (C) 2012 OpenWrt.org
START=91
SERVICE_SIG="KILL"
SERVICE_PID_FILE="/var/run/dhcrelay4.pid"
SERVICE_USE_PID=1
start() {
. /lib/functions/network.sh
config_load dhcrelay
local args=""
local enabled
config_get_bool enabled ipv4 enabled 0
[ "$enabled" -eq 0 ] && return 0
# listen interfaces
local interfaces
local ifname
config_get interfaces ipv4 interfaces
for net in $interfaces; do
if network_get_device ifname "$net"; then
append args "-i $ifname"
fi
done
# link selection sub-option (RFC3527)
local link_selection
config_get link_selection ipv4 link_selection
if network_get_device ifname "$link_selection"; then
append args "-l $ifname"
fi
# relay mode
local relay_mode
config_get relay_mode ipv4 relay_mode
[ -n "$relay_mode" ] && append args "-m $relay_mode"
# dhcp server address
local server
config_get server ipv4 dhcpserver
[ -n "$server" ] || return 0
append args "$server"
service_start /usr/sbin/dhcrelay -4 -q \
-pf $SERVICE_PID_FILE $args
}
stop() {
service_stop /usr/sbin/dhcrelay
}
+42
View File
@@ -0,0 +1,42 @@
#!/bin/sh /etc/rc.common
# Copyright (C) 2012 OpenWrt.org
START=91
SERVICE_SIG="KILL"
SERVICE_PID_FILE="/var/run/dhcrelay6.pid"
SERVICE_USE_PID=1
start() {
local relay_dhcpserver
local relay_upper
local relay_lowers
local relay_lower_args
config_load dhcrelay
config_get relay_dhcpserver ipv6 dhcpserver
config_get relay_upper ipv6 upper
config_get relay_lowers ipv6 lower
# If a specific DHCP server is specified,
# add it to the upper interface.
if [ -n "$relay_dhcpserver" ]; then
relay_upper="${relay_dhcpserver}%$relay_upper"
fi
# Add all lower interfaces at the end.
if [ -n "$relay_lowers" ]; then
local relay_lower
for relay_lower in $relay_lowers; do
append relay_lower_args "-l $relay_lower"
done
fi
service_start /usr/sbin/dhcrelay -6 -q \
-pf $SERVICE_PID_FILE \
-u $relay_upper $relay_lower_args
}
stop() {
service_stop /usr/sbin/dhcrelay
}
+27
View File
@@ -0,0 +1,27 @@
config dhcrelay ipv4
option 'enabled' '0'
# IP address of the server
option 'dhcpserver' '192.0.2.10'
# network interfaces to listen on (e.g. lan or wan)
option 'interfaces' ''
# What to do about packets that already have a relay option:
# 'append': Forward and append our own relay option
# 'replace': Forward, but replace theirs with ours (default)
# 'forward': Forward without changes
# 'discard': Don't forward
option 'relay_mode' ''
# enable RFC3527 link selection sub-option and use the IP address of
# the specified network interface as "uplink" IP address (e.g. wan)
option 'link_selection' ''
config dhcrelay ipv6
# option dhcpserver '2001:db8:1::1'
option upper 'eth1'
list lower 'eth0.2'
list lower 'eth0.3'